unsigned char motorspeed = 100;

#include <IRSendRev.h>
#include <Wire.h>

#define MotorSpeedSet             0x82
#define PWMFrequenceSet           0x84
#define DirectionSet              0xaa
#define MotorSetA                 0xa1
#define MotorSetB                 0xa5
#define Nothing                   0x01
#define Stepernu                  0x1c
#define I2CMotorDriverAdd         0x0f

void setup()
{
  Wire.begin(); // join i2c bus (address optional for master)
  delayMicroseconds(10000);
    Serial.begin(38400);
    IR.Init(A2);
}

unsigned char dta[20];
unsigned char command;

void loop()
{
    if(IR.IsDta())
    {
       IR.Recv(dta);
       Serial.println(dta);
        command = dta[8];
        switch (command) {
          case 208:
          goForward();
          break;
          
          case 224:
          turnRight();
          break;
          
          case 176:
          goBackward();
          break;
          
          case 16:
          turnLeft();
          break;
          
          case 186:
          freeze();
          break;
        }
    }  
}

void MotorSpeedSetAB(unsigned char MotorSpeedA , unsigned char MotorSpeedB)  {
  MotorSpeedA=map(MotorSpeedA,0,100,0,255);
  MotorSpeedB=map(MotorSpeedB,0,100,0,255);
  Wire.beginTransmission(I2CMotorDriverAdd); // transmit to device I2CMotorDriverAdd
  Wire.write(MotorSpeedSet);        // set pwm header 
  Wire.write(MotorSpeedA);              // send pwma 
  Wire.write(MotorSpeedB);              // send pwmb    
  Wire.endTransmission();    // stop transmitting
}

void MotorPWMFrequenceSet(unsigned char Frequence)  {    
  Wire.beginTransmission(I2CMotorDriverAdd); // transmit to device I2CMotorDriverAdd
  Wire.write(PWMFrequenceSet);        // set frequence header
  Wire.write(Frequence);              //  send frequence 
  Wire.write(Nothing);              //  need to send this byte as the third byte(no meaning)  
  Wire.endTransmission();    // stop transmitting
}

void MotorDirectionSet(unsigned char Direction)  {     //  Adjust the direction of the motors 0b0000 I4 I3 I2 I1
  Wire.beginTransmission(I2CMotorDriverAdd); // transmit to device I2CMotorDriverAdd
  Wire.write(DirectionSet);        // Direction control header
  Wire.write(Direction);              // send direction control information
  Wire.write(Nothing);              // need to send this byte as the third byte(no meaning)  
  Wire.endTransmission();    // stop transmitting 
}

void MotorDriectionAndSpeedSet(unsigned char Direction,unsigned char MotorSpeedA,unsigned char MotorSpeedB)  {  //you can adjust the driection and speed together
  MotorDirectionSet(Direction);
  delay(100);
  MotorSpeedSetAB(MotorSpeedA,MotorSpeedB);
  delay(100);  
}

void goForward() {
       MotorDriectionAndSpeedSet(0b1001,motorspeed,motorspeed);
}

void goBackward() {
         MotorDriectionAndSpeedSet(0b0110,motorspeed,motorspeed);
}

void turnRight() {
  MotorDriectionAndSpeedSet(0b1010,motorspeed,motorspeed);
}

void turnLeft() {
  MotorDriectionAndSpeedSet(0b0101,motorspeed,motorspeed);
}

void freeze() {
       MotorDriectionAndSpeedSet(0b1001,0,0);
}
  

  
